require "yast"

module FontsConfig
  class Languages
      LANGUAGES = {
          "ab" => "Abkhazian",
          "aa" => "Afar",
          "af" => "Afrikaans",
          "ak" => "Akan",
          "sq" => "Albanian",
          "am" => "Amharic",
          "an" => "Aragonese",
          "ar" => "Arabic",
          "hy" => "Armenian",
          "as" => "Assamese",
          "av" => "Avaric",
          "ae" => "Avestan",
          "ay" => "Aymara",
          "az" => "Azerbaijani",
          "bm" => "Bambara",
          "ba" => "Bashkir",
          "eu" => "Basque",
          "be" => "Belarusian",
          "bn" => "Bengali",
          "bh" => "Bihari languages",
          "bi" => "Bislama",
          "bs" => "Bosnian",
          "br" => "Breton",
          "bg" => "Bulgarian",
          "my" => "Burmese",
          "ca" => "Catalan",
          "ch" => "Chamorro",
          "ce" => "Chechen",
          "zh" => "Chinese",
          "zh-CN" => "Chinese (China)",
          "zh-HK" => "Chinese (Hong Kong)",
          "zh-SG" => "Chinese (Singapore)",
          "zh-TW" => "Chinese (Thaiwan)",
          "cu" => "Church Slavic",
          "cv" => "Chuvash",
          "kw" => "Cornish",
          "co" => "Corsican",
          "cr" => "Cree",
          "hr" => "Croatian",
          "cs" => "Czech",
          "da" => "Danish",
          "dv" => "Dhivehi",
          "nl" => "Dutch",
          "dz" => "Dzongkha",
          "en" => "English",
          "eo" => "Esperanto",
          "et" => "Estonian",
          "ee" => "Ewe",
          "fo" => "Faroese",
          "fj" => "Fijian",
          "fi" => "Finnish",
          "fr" => "French",
          "fy" => "Western Frisian",
          "ff" => "Fulah",
          "gd" => "Scottish Gaelic",
          "gl" => "Galician",
          "ka" => "Georgian",
          "de" => "German",
          "el" => "Modern Greek (1453-)",
          "gn" => "Guarani",
          "gu" => "Gujarati",
          "ht" => "Haitian",
          "ha" => "Hausa",
          "he" => "Hebrew",
          "iw" => "Hebrew",
          "hz" => "Herero",
          "hi" => "Hindi",
          "ho" => "Hiri Motu",
          "hu" => "Hungarian",
          "is" => "Icelandic",
          "io" => "Ido",
          "ig" => "Igbo",
          "id" => "Indonesian",
          "in" => "Indonesian",
          "iu" => "Inuktitut",
          "ik" => "Inupiaq",
          "ia" => "Interlingua (International Auxiliary Language)",
          "ie" => "Interlingue",
          "ga" => "Irish",
          "it" => "Italian",
          "ja" => "Japanese",
          "jv" => "Javanese",
          "jw" => "Javanese",
          "kl" => "Kalaallisut",
          "kn" => "Kannada",
          "kr" => "Kanuri",
          "ks" => "Kashmiri",
          "kk" => "Kazakh",
          "km" => "Central Khmer",
          "rw" => "Kinyarwanda",
          "ki" => "Kikuyu",
          "ky" => "Kirghiz",
          "kv" => "Komi",
          "kg" => "Kongo",
          "ko" => "Korean",
          "kj" => "Kuanyama",
          "ku" => "Kurdish",
          "la" => "Latin",
          "lo" => "Lao",
          "lv" => "Latvian",
          "li" => "Limburgan",
          "ln" => "Lingala",
          "lt" => "Lithuanian",
          "lu" => "Luba-Katanga",
          "lb" => "Luxembourgish",
          "mk" => "Macedonian",
          "mg" => "Malagasy",
          "ms" => "Malay (macrolanguage)",
          "ml" => "Malayalam",
          "mt" => "Maltese",
          "gv" => "Manx",
          "mi" => "Maori",
          "mr" => "Marathi",
          "mh" => "Marshallese",
          "mo" => "Moldavian",
          "mn" => "Mongolian",
          "na" => "Nauru",
          "nr" => "South Ndebele",
          "ng" => "Ndonga",
          "ne" => "Nepali (macrolanguage)",
          "nd" => "North Ndebele",
          "no" => "Norwegian",
          "nb" => "Norwegian Bokmål",
          "nn" => "Norwegian Nynorsk",
          "nv" => "Navajo",
          "ny" => "Nyanja",
          "oc" => "Occitan (post 1500)",
          "oj" => "Ojibwa",
          "or" => "Oriya (macrolanguage)",
          "om" => "Oromo",
          "os" => "Ossetian",
          "pi" => "Pali",
          "pa" => "Panjabi",
          "fa" => "Persian",
          "pl" => "Polish",
          "pt" => "Portuguese",
          "ps" => "Pushto",
          "qu" => "Quechua",
          "ro" => "Romanian",
          "rm" => "Romansh",
          "rn" => "Rundi",
          "ru" => "Russian",
          "se" => "Northern Sami",
          "sm" => "Samoan",
          "sg" => "Sango",
          "sa" => "Sanskrit",
          "sc" => "Sardinian",
          "sr" => "Serbian",
          "sh" => "Serbo-Croatian",
          "sn" => "Shona",
          "sd" => "Sindhi",
          "es" => "Spanish",
          "si" => "Sinhala",
          "sk" => "Slovak",
          "sl" => "Slovenian",
          "so" => "Somali",
          "st" => "Southern Sotho",
          "su" => "Sundanese",
          "sw" => "Swahili (macrolanguage)",
          "ss" => "Swati",
          "sv" => "Swedish",
          "tl" => "Tagalog",
          "ty" => "Tahitian",
          "tg" => "Tajik",
          "ta" => "Tamil",
          "tt" => "Tatar",
          "bo" => "Tibetan",
          "te" => "Telugu",
          "th" => "Thai",
          "ti" => "Tigrinya",
          "to" => "Tonga (Tonga Islands)",
          "ts" => "Tsonga",
          "tn" => "Tswana",
          "tk" => "Turkmen",
          "tr" => "Turkish",
          "tw" => "Twi",
          "ug" => "Uighur",
          "uk" => "Ukrainian",
          "ur" => "Urdu",
          "uz" => "Uzbek",
          "ve" => "Venda",
          "vi" => "Vietnamese",
          "vo" => "Volapük",
          "wa" => "Walloon",
          "cy" => "Welsh",
          "wo" => "Wolof",
          "xh" => "Xhosa",
          "ii" => "Sichuan Yi",
          "ji" => "Yiddish",
          "yi" => "Yiddish",
          "yo" => "Yoruba",
          "za" => "Zhuang",
          "zu" => "Zulu",
        }

    def self.languages
      LANGUAGES
    end

    def self.names(keys)
      # act on known language abbreviations only
      names = keys.map do |key|
        LANGUAGES[key]
      end
      names.delete(nil)
      return names
    end
  end

  class SelectEBLDialog
    include Yast
    include UIShortcuts
    include I18n

    def initialize
      textdomain "fonts"
    end

    def run(selected_langs)
      Yast.import "UI"
      items = Languages::languages.keys.map do |lang|
                Item(Id(lang),
                     Languages::languages[lang] + " (" + lang + ")",
                     selected_langs.include?(lang))
              end
      # save unknown langs
      unknown_langs = selected_langs.map do |lang|
                      Languages::languages.include?(lang) ? nil : lang
                    end
      unknown_langs.delete(nil)

      dialog_content = VBox(
                        MinSize(35, 16,
                               MultiSelectionBox(Id("mchkb_languages"),
                                                 _("&Languages"),
                                                 items)),
                        HBox(PushButton(Id("btn_cancel"), _("&Cancel")),
                             PushButton(Id("btn_ok"), _("&Ok"))),
                       )
      UI.OpenDialog dialog_content

      begin
        return controller_loop(selected_langs, unknown_langs)
      ensure
        UI.CloseDialog
      end
    end

  private
    def controller_loop(selected_langs, unknown_langs)
      while true do
        input = UI.UserInput
        case input
          when "btn_ok"
            items = UI.QueryWidget(Id("mchkb_languages"),
                                   :SelectedItems)
            # load unknown langs back
            return items.concat(unknown_langs)
          when "btn_cancel"
            return selected_langs
        end
      end
    end
  end
end
